var Base = require('./base')

exports.config = Base.config
exports.apiConfig = Base.apiConfig
exports.env = Base.env

// Low-level / internal utilities.
exports.api = Base.api
exports.logger = Base.logger

var debug = Base.logger('io')

exports.io = function(config){
  Base.config(config)
  return function(req, res, next){
    Base.bouncer.validateFaasSecurity(req, function(err, trustedObj){
      if (err) { debug('error', err) }
      req.session.faas = err ? {} : trustedObj
      next() // go to routes
    })
  }
}
