Promise = require('bluebird')
FS = require('fs')
Http = require('http')

Base = require('../base')


debug = Base.logger('client_info')

_deviceData = false
deviceData = null
_ec2Data = false
ec2Data = null

exports.clientInfo = ->
  info = null
  getDeviceData()
  .then (device) ->
    info = device
    if Base.env.IX_USE_EC2
      getEc2Data()
    else
      null
  .then (ec2Data) ->
    info.ec2Zone = ec2Data.availabilityZone if ec2Data?.availabilityZone
    info.deviceKey ?= info.key if info.key
    info.deviceSecret ?= info.secret if info.secret
    info

getDeviceData = ->
  return Promise.resolve(deviceData) if _deviceData
  deviceData ?= { secret: Base.env.IX_DEVICE_SECRET }
  getDeviceDataHelper()
  .then ->
    _deviceData = true
    deviceData

getDeviceDataHelper = ->
  if Base.env.IX_DEVICE_KEY
    console.log('DEVICE KEY: '+Base.env.IX_DEVICE_KEY)
    deviceData.key = Base.env.IX_DEVICE_KEY
    Promise.resolve()
  else if Base.env.IX_DEVICE_KEY_FILE && IX_DEVICE_KEY_FILE != 'NONE'
    Promise.fromCallback (callback) ->
      # '/factory/serial_number'
      FS.readFile(Base.env.IX_DEVICE_KEY_FILE, { encoding: 'utf8' }, callback)
    .then (file) ->
      debug('getDeviceData file:', file)
      key = file.split(/\n/)[0].trim()
      console.log('DEVICE KEY: '+key)
      deviceData.key = key
    , (err) ->
      debug('getDeviceData error:', err)
  else
    Promise.resolve()

getEc2Data = ->
  return Promise.resolve(ec2Data) if _ec2Data
  new Promise (resolve, reject) ->
    myResolve = (val) ->
      _ec2Data = true
      ec2Data = val
      resolve(val)
    request = Http.get 'http://169.254.169.254/latest/meta-data/placement/availability-zone', (response) ->
      resp = ''
      response.on 'data', (chunk) ->
        resp += chunk
      response.on 'error', (err) ->
        myResolve()
      response.on 'end', ->
        myResolve({ availabilityZone: resp })
    request.on 'error', (err) ->
      debug('ec2 error', err)
      myResolve()
