var npmDebug = require('debug')

module.exports = function(debugToken){
  var debug = npmDebug('faas:'+debugToken)
  var logger = function(){
    var args = Array.prototype.slice.call(arguments, 0)
    if (typeof args[0] === 'object') {
      args.unshift('->')
    }
    debug.apply(this, args)
  }

  ////
  // Helper for the following pattern:
  //
  //   callback = function(err,data){ debug('cb-err cb-data' , err, data); _callback(err,data) }
  //
  // Instead, do this:
  //   callback = debug.wrap(_callback)
  ////
  logger.wrap = function(callback){
    return function(){
      var args = Array.prototype.slice.call(arguments,0)
      args.unshift('callback')
      logger.apply(this, args)
      callback.apply(this, arguments)
    }
  }

  return logger
}
