var util = require('util')

exports.extend = function(){
  var obj = arguments[0]
  var obj2, i, k
  for (i = 1; i < arguments.length; i++) {
    obj2 = arguments[i]
    if (obj2) {
      for (k in obj2) {
        if (obj2.hasOwnProperty(k)) {
          obj[k] = obj2[k]
        }
      }
    }
  }
  return obj
}

exports.shallowCopy = function(obj){
  var copy
  if (util.isArray(obj)) {
    copy = obj.slice(0)
  }
  else {
    copy = exports.extend({}, obj)
  }
  return copy
}

exports.isFunction = function(obj){
  return (typeof obj === 'function')
}

exports.isFobject = function(obj){
  if (obj) {
    var type = (typeof obj)
    if (type === 'function') { return true }
    if (type === 'object') {
      type = Object.prototype.toString.call(obj).match(/\w+/g)[1].toLowerCase()
      return !(type === 'array' || type === 'boolean' || type === 'date' || type === 'number' || type === 'regexp' || type === 'string')
    }
  }
  return false
}
